package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;

/**
 * <p>^Cg:  Gear base</p>
 * <p>:    ׂĂ̎ԃNX̊b</p>
 * <p>쌠: Copyright (c) 2002 m.matsubara </p>
 * @author m.matsubara
 * @version 1.0
 */

public abstract class GearBase {
  int m_nPosX = 0;
  int m_nPosY = 0;
  double m_rSize = 100;
  double m_rAngle = 0.0;  //  Ԃ̌Xiǂꂾ]Ă邩EWAj
  Color m_color1 = Color.white;
  Color m_color2 = Color.blue;

  public GearBase() {
  }
  /**
   * MA̒SʒuXW擾
   * @return MA̒SXW
   */
  public int getPosX() {
    return m_nPosX;
  }
  /**
   * MA̒SʒuXWݒ肷
   * @param newPosX VMA̒SʒuXW
   */
  public void setPosX(int newPosX) {
    m_nPosX = newPosX;
  }
  /**
   * MA̒SʒuYW擾
   * @return MA̒SYW
   */
  public int getPosY() {
    return m_nPosY;
  }
  /**
   * MA̒SʒuYWݒ肷
   * @param newPosY VMA̒SʒuYW
   */
  public void setPosY(int newPosY) {
    m_nPosY = newPosY;
  }
  /**
   * MA̔a擾
   * @return MA̔a
   */
  public double getSize() {
    return m_rSize;
  }
  /**
   * MA̔aݒ肷
   * @param newSize VMA̔a
   */
  public void setSize(double newSize) {
    m_rSize = newSize;
  }
  /**
   * px擾
   * @return WAł݂̌̊pxiO`Q΁j
   */
  public double getAngle() {
    return m_rAngle;
  }
  /**
   * pxݒ肷
   * l O`Q OƎIɂ͈̔͂Ɏ܂悤vZȂ
   * @param newAngle VpxiWAj
   */
  public void setAngle(double newAngle) {
    m_rAngle = newAngle;
    m_rAngle %= (2 * Math.PI);
    if (m_rAngle < 0)
      m_rAngle += 2 * Math.PI;

  }
  /**
   * J[1擾
   * @return ݂̃J[1
   */
  public Color getColor1() {
    return m_color1;
  }
  /**
   * J[1ݒ肷
   * @param newColor1 VJ[1
   */
  public void setColor1(Color newColor1) {
    m_color1 = newColor1;
  }
  /**
   * J[2擾
   * @return ݂̃J[2
   */
  public Color getColor2() {
    return m_color2;
  }
  /**
   * J[2ݒ肷
   * @param newColor2 VJ[2
   */
  public void setColor2(Color newColor2) {
    m_color2 = newColor2;
  }
  /**
   * ݂̊pxgXWvẐɎg
   * @param nSize XW
   * @param rDefAngle angle ɒǉČvZpx
   * @return vZꂽ XW
   */
  public int rotateX(int nSize, double rDefAngle) {
    return (int)(m_nPosX + nSize * Math.cos(m_rAngle + rDefAngle));
  }
  /**
   * ݂̊pxgYWvẐɎg
   * @param nSize YW
   * @param rDefAngle angle ɒǉČvZpx
   * @return vZꂽ YW
   */
  public int rotateY(int nSize, double rDefAngle) {
    return (int)(m_nPosY + nSize * Math.sin(m_rAngle + rDefAngle));
  }
  /**
   * ݂̊pxgXWvẐɎg
   * @param rSize XW
   * @param rDefAngle angle ɒǉČvZpx
   * @return vZꂽ XW
   */
  public int rotateX(double rSize, double rDefAngle) {
    return (int)(m_nPosX + rSize * Math.cos(m_rAngle + rDefAngle));
  }
  /**
   * ݂̊pxgYWvẐɎg
   * @param rSize YW
   * @param rDefAngle angle ɒǉČvZpx
   * @return vZꂽ YW
   */
  public int rotateY(double rSize, double rDefAngle) {
    return (int)(m_nPosY + rSize * Math.sin(m_rAngle + rDefAngle));
  }

  /**
   * MA`悷TuNXŒ`Ȃ΂ȂȂ
   * @param g `Ɏg Graphics IuWFNg
   */
  public abstract void draw(Graphics g);
}